<?php
/**
*
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2009 Jan Kulmann <jankul@zmml.uni-bremen.de>
// ATTENTION: Please send ALL bug reports and security leaks directly to the author.
//            Thx!
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class StudIPTwitterDB {

	private $user_id;
	private $req_user_id = '';

	public function __construct() {
		
	}

	public function setUserId($s) {
		$this->user_id = $s;
	}

	public function setReqUserId($s) {
		$this->req_user_id = $s;
	}

	public function getTwitterUsername($user_id) {
		$db = DBManager::get();
		$sql = sprintf("SELECT tw_username FROM tw_options WHERE user_id='%s'", $user_id);
                $result = $db->query($sql)->fetchAll();
                if (count($result))
                        return $result[0]['tw_username'];
                else
                        return FALSE;
	}

	public function getOptions() {
		$db = DBManager::get();
                $sql = sprintf("SELECT * FROM tw_options WHERE user_id='%s'", $this->user_id);
                $result = $db->query($sql)->fetchAll();
		if (count($result))
	                return $result;
		else
			return FALSE;
	}

	public function setOptions($options) {
		$db = DBManager::get();
		if ($this->getOptions()) {
			if ($options['tw_username'] == '' || $options['tw_password'] == '')
				$sql = sprintf("DELETE FROM tw_options WHERE user_id='%s'",$this->user_id);
			else
				$sql = sprintf("UPDATE tw_options SET tw_username='%s', tw_password='%s', show_tw_friends=%d WHERE user_id='%s'", $options['tw_username'], base64_encode($options['tw_password']), $options['show_tw_friends'], $this->user_id);
		} else {
			$new_id = md5(uniqid(time().$this->user_id));
			$sql = sprintf("INSERT INTO tw_options (option_id, user_id, tw_username, tw_password, show_tw_friends) VALUES ('%s','%s','%s','%s',%d)",$new_id,$this->user_id, $options['tw_username'], base64_encode($options['tw_password']), $options['show_tw_friends']);
		}
		$db->query($sql);
	}

	public function readCache($mode, $keyword=FALSE) {
		$db = DBManager::get();
                $stmt = $db->prepare("SELECT cache FROM tw_cache WHERE user_id=? AND cache_type=? AND req_user_id=? AND wall_keyword=?");
		$stmt->execute(array($this->user_id, $mode, $this->req_user_id, ($keyword ? $keyword : '')));
		if ($row = $stmt->fetch())
			return base64_decode($row['cache']);
		else
			return FALSE;
	}

	public function saveCache($data, $mode, $keyword=FALSE) {
		$db = DBManager::get();
		if ($this->readCache($mode, $keyword)) {
	                $stmt = $db->prepare("UPDATE tw_cache SET cache=?, chdate=UNIX_TIMESTAMP() WHERE user_id=? AND cache_type=? AND req_user_id=? AND wall_keyword=?");
			$stmt->execute(array(base64_encode($data), $this->user_id, $mode, $this->req_user_id, ($keyword ? $keyword : '')));
		} else {
			$new_id = md5(uniqid(time().$this->user_id));
			$stmt = $db->prepare("INSERT INTO tw_cache (cache_id, user_id, req_user_id, cache, chdate, cache_type, wall_keyword) VALUE (?, ?, ?, ?, UNIX_TIMESTAMP(), ?, ?)");
			$stmt->execute(array($new_id, $this->user_id, $this->req_user_id, base64_encode($data), $mode, ($keyword ? $keyword : '')));
		}
	}

	public function getCacheLastModified($mode, $keyword=FALSE) {
		$db = DBManager::get();
                $stmt = $db->prepare("SELECT chdate FROM tw_cache WHERE user_id=? AND cache_type=? AND req_user_id=? AND wall_keyword=?");
		$stmt->execute(array($this->user_id, $mode, $this->req_user_id, ($keyword ? $keyword : '')));
		if ($row = $stmt->fetch())
			return $row['chdate'];
		else
			return 0;

	}

	public function getWalls($range_id=FALSE) {
		$db = DBManager::get();
		if ($range_id)
			$sql = sprintf("SELECT * FROM tw_walls WHERE range_id='%s'",$range_id);
		else
			$sql = sprintf("SELECT * FROM tw_walls WHERE user_id='%s' AND (range_id='' OR range_id IS NULL)",$this->user_id);
		$result = $db->query($sql)->fetchAll();
		if (count($result))
			return $result;
		else
			return FALSE;
	}

	public function getWall($wall_id, $range_id=FALSE) {
		$db = DBManager::get();
		if ($range_id)
			$sql = sprintf("SELECT * FROM tw_walls WHERE wall_id='%s' AND range_id='%s'",$wall_id, $range_id);
		else
			$sql = sprintf("SELECT * FROM tw_walls WHERE wall_id='%s' AND user_id='%s' AND (range_id='' OR range_id IS NULL)",$wall_id,$this->user_id);
		$result = $db->query($sql)->fetchAll();
		if (count($result))
			return $result[0];
		else
			return FALSE;
	}

	public function saveWall($keyword, $range_id=FALSE) {
		$db = DBManager::get();
		$new_id = md5(uniqid(time().$this->user_id));
		$stmt = $db->prepare("INSERT INTO tw_walls (wall_id, user_id, wall_keyword, mkdate, range_id) VALUES (?,?,?, UNIX_TIMESTAMP(),?)");
		$stmt->execute(array($new_id, $this->user_id, trim(stripslashes($keyword)), ($range_id ? $range_id : '')));
	}

	public function removeWall($wall_id, $range_id=FALSE) {
		$db = DBManager::get();
		if ($range_id && $GLOBALS['perm']->have_studip_perm('tutor',$range_id)) {
			$stmt = $db->prepare("DELETE FROM tw_walls WHERE wall_id=? AND range_id=?");
			$stmt->execute(array($wall_id, $range_id));
		} else {
			$stmt = $db->prepare("DELETE FROM tw_walls WHERE user_id=? AND wall_id=?");
			$stmt->execute(array($this->user_id, $wall_id));
		}
	}

}

?>
