<?php
/**
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2009 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+


class AddTwitterWall extends DBMigration {

        function description () {
                return 'database changes to add twitter wall function for reloaded plugin';
        }

        function up () {
                $this->db->query("
CREATE TABLE IF NOT EXISTS `tw_walls` (
  `wall_id` varchar(32) NOT NULL,
  `user_id` varchar(32) NOT NULL,
  `wall_keyword` varchar(255) NOT NULL,
  `mkdate` int(20) NOT NULL,
  `range_id` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`wall_id`),
  KEY `user_id` (`user_id`),
  KEY `range_id` (`range_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1");
		$this->db->query("ALTER TABLE `tw_cache` CHANGE `cache_type` `cache_type` ENUM( 'user_timeline', 'public_timeline', 'friends_timeline', 'wall_timeline' ) NOT NULL DEFAULT 'user_timeline'");
		$this->db->query("ALTER TABLE `tw_cache` ADD `wall_keyword` VARCHAR( 255 ) NOT NULL DEFAULT ''");
	}

        function down () {
                $this->db->query("DROP TABLE `tw_walls`");
                $this->db->query("ALTER TALBE `tw_cache` DROP `wall_keyword`");
		$this->db->query("ALTER TABLE `tw_cache` CHANGE `cache_type` `cache_type` ENUM( 'user_timeline', 'public_timeline', 'friends_timeline' ) NOT NULL DEFAULT 'user_timeline'");
        }

}

?>
